## toil 5.7.1

=== Makefile ===
# Copyright (C) 2015-2021 Regents of the University of California
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
include common.mk

define help

Supported targets: prepare, develop, docs, sdist, clean, test, docker, and push_docker.

Please note that all build targets require a virtualenv to be active.

The 'prepare' target installs Toil's build requirements into the current virtualenv.

The 'develop' target creates an editable install of Toil and its runtime requirements in the
current virtualenv. The install is called 'editable' because changes to the source code
immediately affect the virtualenv. Set the 'extras' variable to ensure that the 'develop' target
installs support for extras; some tests require extras to be installed. Consult setup.py for the
list of supported extras. To install Toil in develop mode with all extras, run

	make develop extras=[all]

The 'sdist' target creates a source distribution of Toil. It is used for some unit tests and for
installing the currently checked out version of Toil into the appliance image.

The 'clean' target cleans up the side effects of 'develop', 'sdist', 'docs', and 'docker'
on this machine. It does not undo externally visible effects like removing packages already
uploaded to PyPI.

The 'docs' target uses Sphinx to create HTML documentation in the docs/_build directory

Targets are provided to run Toil's tests. Note that these targets do *not* automatically install
Toil's dependencies; it is recommended to 'make develop' before running any of them.

The 'test' target runs Toil's unit tests serially with pytest. It will run some docker tests and
setup. Note: this target does not capture output from the terminal. For any of the test targets,
set the 'tests' variable to run a particular test, e.g.

	make test tests=src/toil/test/sort/sortTest.py::SortTest::testSort
    
The 'cov' variable can be set to '' to suppress the test coverage report.
    
The 'test_offline' target is similar, but runs only tests that don't need
Internet or Docker by default.  The 'test_offline' target takes the same
arguments as the 'test' target.

    make test_offline tests=src/toil/test/src/threadingTest.py

The 'docker' target builds the Docker images that make up the Toil appliance. You may set the
TOIL_DOCKER_REGISTRY variable to override the default registry that the 'push_docker' target pushes
the appliance images to, for example:

	TOIL_DOCKER_REGISTRY=quay.io/USER make docker

If Docker is not installed, Docker-related targets tasks and tests will be skipped. The
same can be achieved by setting TOIL_DOCKER_REGISTRY to an empty string.

The 'push_docker' target pushes the Toil appliance images to a remote Docker registry. It
requires the TOIL_DOCKER_REGISTRY variable to be set to a value other than the default to avoid
accidentally pushing to the official Docker registry for Toil.

The TOIL_DOCKER_NAME environment variable can be set to customize the appliance image name that
is created by the 'docker' target and pushed by the 'push_docker' target.

endef
export help
help:
	@printf "$$help"


# This Makefile uses bash features like printf and <()
SHELL=bash
tests=src/toil/test
arch=linux/amd64,linux/arm64
cov="--cov=toil"
extras=
# You can say make develop packages=xxx to install packages in the same Python
# environment as Toil itself without creating dependency conflicts with Toil
packages=
sdist_name:=toil-$(shell python version_template.py distVersion).tar.gz

green=\033[0;32m
normal=\033[0m
red=\033[0;31m
cyan=\033[0;36m

develop: check_venv
	pip install -e .$(extras) $(packages)

clean_develop: check_venv
	- rm -rf src/*.egg-info
	- rm src/toil/version.py

uninstall:
	- pip uninstall -y toil

sdist: dist/$(sdist_name)

dist/$(sdist_name): check_venv
	@test -f dist/$(sdist_name) && mv dist/$(sdist_name) dist/$(sdist_name).old || true
	python setup.py sdist
	@test -f dist/$(sdist_name).old \
	    && ( cmp -s <(tar -xOzf dist/$(sdist_name)) <(tar -xOzf dist/$(sdist_name).old) \
	         && mv dist/$(sdist_name).old dist/$(sdist_name) \
	         && printf "$(cyan)No significant changes to sdist, reinstating backup.$(normal)\n" \
	         || rm dist/$(sdist_name).old ) \
	    || true

clean_sdist:
	- rm -rf dist
	- rm src/toil/version.py

# Setting SET_OWNER_TAG will tag cloud resources so that UCSC's cloud murder bot won't kill them.
test: check_venv check_build_reqs
	TOIL_OWNER_TAG="shared" \
	    python -m pytest --durations=0 --strict-markers --log-level DEBUG --log-cli-level INFO -r s $(cov) $(tests)


# This target will skip building docker and all docker based tests
test_offline: check_venv check_build_reqs
	@printf "$(cyan)All docker related tests will be skipped.$(normal)\n"
	TOIL_SKIP_DOCKER=True \
	    python -m pytest -vv --timeout=600 --strict-markers --log-level DEBUG --log-cli-level INFO $(cov) $(tests)

ifdef TOIL_DOCKER_REGISTRY

docker_image:=$(TOIL_DOCKER_REGISTRY)/$(TOIL_DOCKER_NAME)
grafana_image:=$(TOIL_DOCKER_REGISTRY)/toil-grafana
prometheus_image:=$(TOIL_DOCKER_REGISTRY)/toil-prometheus
mtail_image:=$(TOIL_DOCKER_REGISTRY)/toil-mtail

define tag_docker
	@printf "$(cyan)Removing old tag $2. This may fail but that's expected.$(normal)\n"
	-docker rmi $2
	docker tag $1 $2
	@printf "$(green)Tagged appliance image $1 as $2.$(normal)\n"
endef

docker: toil_docker prometheus_docker grafana_docker mtail_docker

pre_pull_docker:
	# Pre-pull everything
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull ubuntu:20.04 && break || sleep 60; done
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull prom/prometheus:v2.24.1 && break || sleep 60; done
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull grafana/grafana && break || sleep 60; done
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull sscaling/mtail && break || sleep 60; done

toil_docker: pre_pull_docker docker/Dockerfile
	@set -ex \
	; cd docker \
	; docker buildx build --platform=$(arch) --tag=$(docker_image):$(TOIL_DOCKER_TAG) -f Dockerfile .

prometheus_docker: pre_pull_docker
	@set -ex \
	; cd dashboard/prometheus \
	; docker buildx build --platform=$(arch) --tag=$(prometheus_image):$(TOIL_DOCKER_TAG) -f Dockerfile .

grafana_docker: pre_pull_docker
	@set -ex \
	; cd dashboard/grafana \
	; docker buildx build --platform=$(arch) --tag=$(grafana_image):$(TOIL_DOCKER_TAG) -f Dockerfile .

mtail_docker: pre_pull_docker
	@set -ex \
	; cd dashboard/mtail \
	; docker buildx build --platform=$(arch) --tag=$(mtail_image):$(TOIL_DOCKER_TAG) -f Dockerfile .

docker/$(sdist_name): dist/$(sdist_name)
	cp $< $@

docker/Dockerfile: docker/Dockerfile.py docker/$(sdist_name)
	_TOIL_SDIST_NAME=$(sdist_name) python docker/Dockerfile.py > $@

clean_docker:
	-rm docker/Dockerfile docker/$(sdist_name)
	-docker rmi $(docker_image):$(TOIL_DOCKER_TAG)

push_docker: docker
	# Weird if logic is so we fail if all the pushes fail
	cd docker ; for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker buildx build --platform $(arch) --push --tag=$(docker_image):$(TOIL_DOCKER_TAG) -f Dockerfile . && break || sleep 60; done
	cd dashboard/prometheus ; for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker buildx build --platform $(arch) --push --tag=$(prometheus_image):$(TOIL_DOCKER_TAG) -f Dockerfile . && break || sleep 60; done
	cd dashboard/grafana ; for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker buildx build --platform $(arch) --push --tag=$(grafana_image):$(TOIL_DOCKER_TAG) -f Dockerfile . && break || sleep 60; done
	cd dashboard/mtail ; for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker buildx build --platform $(arch) --push --tag=$(mtail_image):$(TOIL_DOCKER_TAG) -f Dockerfile . && break || sleep 60; done

else

docker docker_push clean_docker:
	@printf "$(cyan)Skipping '$@' target as TOIL_DOCKER_REGISTRY is empty or Docker is not installed.$(normal)\n"

endif


docs: check_venv check_build_reqs
	# Strange, but seemingly benign Sphinx warning floods stderr if not filtered:
	cd docs && make html

clean_docs: check_venv
	- cd docs && make clean

clean: clean_develop clean_sdist clean_docs

check_build_reqs:
	@(python -c 'import mock; import pytest' && which sphinx-build >/dev/null) \
		|| ( printf "$(red)Build requirements are missing. Run 'make prepare' to install them.$(normal)\n" ; false )

prepare: check_venv
	pip install -r requirements-dev.txt

check_venv:
	@python -c 'import sys, os; sys.exit( int( 0 if "VIRTUAL_ENV" in os.environ else 1 ) )' \
		|| ( printf "$(red)A virtualenv must be active.$(normal)\n" ; false )

check_clean_working_copy:
	@printf "$(green)Checking if your working copy is clean ...$(normal)\n"
	@git diff --exit-code > /dev/null \
		|| ( printf "$(red)Your working copy looks dirty.$(normal)\n" ; false )
	@git diff --cached --exit-code > /dev/null \
		|| ( printf "$(red)Your index looks dirty.$(normal)\n" ; false )
	@test -z "$$(git ls-files --other --exclude-standard --directory)" \
		|| ( printf "$(red)You have untracked files:$(normal)\n" \
			; git ls-files --other --exclude-standard --directory \
			; false )

check_cpickle:
	# fail if cPickle.dump(s) called without HIGHEST_PROTOCOL
	# https://github.com/BD2KGenomics/toil/issues/1503
	! find src -iname '*.py' | xargs grep 'cPickle.dump' | grep --invert-match HIGHEST_PROTOCOL

PYSOURCES=$(shell find src -name '*.py') setup.py version_template.py

# Linting and code style related targets
## sorting imports using isort: https://github.com/timothycrosley/isort
sort_imports: $(PYSOURCES)
	isort -m VERTICAL $^
	make format

remove_unused_imports: $(PYSOURCES)
	autoflake --in-place --remove-all-unused-imports $^
	make format

remove_trailing_whitespace:
	$(CURDIR)/contrib/admin/remove_trailing_whitespace.py

format: $(wildcard src/toil/cwl/*.py)
	black $^

mypy:
	$(CURDIR)/contrib/admin/mypy-with-ignore.py

pydocstyle_report.txt: src/toil
	pydocstyle setup.py $^ > $@ 2>&1 || true

diff_pydocstyle_report: pydocstyle_report.txt
	diff-quality --compare-branch=master --violations=pycodestyle --fail-under=100 $^

diff_mypy:
	mypy --cobertura-xml-report . src/toil || true
	diff-cover --fail-under=100 cobertura.xml

pyupgrade: $(PYSOURCES)
	pyupgrade --exit-zero-even-if-changed --py36-plus $^

flake8: $(PYSOURCES)
	flake8 --ignore=E501,W293,W291,E265,E302,E722,E126,E303,E261,E201,E202,W503,W504,W391,E128,E301,E127,E502,E129,E262,E111,E117,E306,E203,E231,E226,E741,E122,E251,E305,E701,E222,E225,E241,E305,E123,E121,E703,E704,E125,E402 $^

.PHONY: help \
		prepare \
		check_cpickle \
		develop clean_develop \
		sdist clean_sdist \
		test test_offline \
		docs clean_docs \
		clean \
		format mypy sort_imports remove_unused_imports \
		check_venv \
		check_clean_working_copy \
		check_build_reqs \
		docker clean_docker push_docker \
		pre_pull_docker toil_docker prometheus_docker grafana_docker mtail_docker

=== debian/changelog ===
toil (5.7.1-1) unstable; urgency=medium

  * d/watch: update for new tag structure
  * New upstream version
  * refresh patches
  * d/patches/typing_fix: workaround for us skipping the AWS extra
    during building
  * d/patches/newer_cwltool: the expression module is now part of cwl-utils,
    not cwltool
  * d/rules: skip more tests that fail when run as root
  * d/patches/test_safe_paths: fix for running tests post-installation
  * d/tests/run-unit-tests: skip same tests we skip in d/rules

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 21 Dec 2022 11:30:22 +0100

toil (5.6.0-7) unstable; urgency=medium

  * Team upload.
  * Packaging update
  * Standards-Version: 4.6.1 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Drop unnecessary dependency on build-essential.
  * Make sure the doc applies to Debian installations with Python3
  * Update lintian-overrides
  * Set python3.10 instead of python3.9 in setting_version.patch
    Closes: #1013275

 -- Andreas Tille <tille@debian.org>  Mon, 18 Jul 2022 17:39:37 +0200

toil (5.6.0-6) unstable; urgency=medium

  * Team Upload.
  * d/t/control: Test dep on python3-all (Closes: #1009201)

 -- Nilesh Patra <nilesh@debian.org>  Sat, 16 Apr 2022 00:13:39 +0530

toil (5.6.0-5) unstable; urgency=medium

  * Team Upload.
  * d/t/control: Do not run autopkgtests on arm64

 -- Nilesh Patra <nilesh@debian.org>  Sat, 12 Mar 2022 01:41:12 +0530

toil (5.6.0-4) unstable; urgency=medium

  * Team Upload.
  * d/salsa-ci.yml: Disable reprotest
  * Apply patches before running autopkgtests

 -- Nilesh Patra <nilesh@debian.org>  Fri, 11 Mar 2022 03:46:49 +0530

toil (5.6.0-3) unstable; urgency=medium

  * Team Upload.
  * Add patch to fix FTBFS with jobStores
    tests (Closes: #1005479)

 -- Nilesh Patra <nilesh@debian.org>  Thu, 10 Mar 2022 17:55:25 +0530

toil (5.6.0-2) unstable; urgency=medium

  * {Autopkg,}tests: sync the skiped tests

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 24 Jan 2022 11:42:07 +0100

=== debian/control ===
Source: toil
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3-all:any,
               python3-setuptools,
               python3-docker,
               python3-dill,
               python3-future,
               cwltool (>= 3.1.20220628170238),
               python3-distutils,
               python3-enlighten,
               python3-wdlparse,
               python3-pytest <!nocheck>,
               python3-mock <!nocheck>,
               python3-boto3 (>=1.17) <!nocheck>,
               python3-boto <!nocheck>,
               python3-stubserver <!nocheck>,
               rsync <!nocheck>,
               python3-yaml <!nocheck>,
               python3-urllib3,
               python3-sphinx
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/toil
Vcs-Git: https://salsa.debian.org/med-team/toil.git
Homepage: https://github.com/BD2KGenomics/toil
Rules-Requires-Root: no

Package: toil
Architecture: all
Depends: ${python3:Depends},
         ${misc:Depends},
         python3-distutils,
         cwltool (>= 3.1.20211104071347)
Recommends: python3-boto,
            python3-boto3,
# for WDL support
            python3-wdlparse,
# for google cloud support
            python3-libcloud
# for mesos support, but needs python3-mesos first
#         python3-protobuf,
Suggests: docker.io | singularity-container | docker-ce,
          python3-azure,
          python3-azure-storage,
          python3-idna,
Provides: cwl-runner
#Suggests: python-toil-doc
Description: cross-platform workflow engine
 Toil is a scalable, efficient, cross-platform and easy-to-use workflow
 engine in pure Python.  It works with several well established load
 balancers like Slurm or the Sun Grid Engine.  Toil is also compatible with
 the Common Workflow Language (CWL) via the "toil-cwl-runner" interface, which
 this package make available via the Debian alternativess system under the
 alias "cwl-runner".

#Package: python-toil-doc
#Architecture: all
#Section: doc
#Depends: ${sphinxdoc:Depends}, ${misc:Depends}
#Description: cross-platform workflow engine (common documentation)
# The documentation of Toil shall go here at some point.
# .
# This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export PYBUILD_NAME=toil

export PYBUILD_DESTDIR_python3=debian/toil/

#export PYBUILD_DISABLE=test
export PYBUILD_DISABLE_python2=1
%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	PYTHONPATH=$(CURDIR)/src $(MAKE) -C docs man

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian -name cwltoil -delete
	# remove the below once mesos is packaged and tested
	find $(CURDIR)/debian -name _toil_mesos_executor -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	PYBUILD_SYSTEM=custom \
		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -vv -W ignore --ignore src/toil/test/lib/aws/test_s3.py --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/toilwdlTest.py --ignore src/toil/test/cwl/cwlTest.py --ignore src/toil/test/src/promisedRequirementTest.py --ignore src/toil/test/lib/test_ec2.py --ignore src/toil/test/batchSystems/batchSystemTest.py -k "not (test_bioconda or test_run_conformance or testImportFtpFile or ToilWdlIntegrationTest or SortTest or testCwlexample or testVirtualEnv or ToilDocumentationTest or test_cwl_toil_kill or testImportReadFileCompatibility or CleanWorkDirTest or DeferredFunctionTest)" {dir}/src/toil/test' \
		dh_auto_test
endif

# If you need to rebuild the Sphinx documentation
# Add spinxdoc to the dh --with line
#override_dh_auto_build:
#	dh_auto_build
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bhtml docs/ build/html # HTML generator
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bman  docs/ build/man  # Manpage generator

override_dh_auto_clean:
	rm -rf .pybuild
	rm -rf docs/_build
	find . -name "*.pyc" -delete

=== debian/tests/control ===
Tests: smoke-test
Depends: toil, python3-wdlparse
Restrictions: allow-stderr, superficial

Tests: run-unit-tests
Depends: toil, python3, python3-wdlparse, python3-pytest, python3-mock, python3-boto3, rsync, python3-boto, python3-stubserver, python3-yaml, quilt
Restrictions: allow-stderr, needs-internet
Architecture: !arm64

## toil 5.8.0

=== Makefile ===
--- 
+++ 
@@ -61,6 +61,11 @@
 
 	TOIL_DOCKER_REGISTRY=quay.io/USER make docker
 
+You might also want to build just for one architecture and load into your
+Docker daemon. We have a 'load_docker' target for this.
+
+    make load_docker arch=amd64
+
 If Docker is not installed, Docker-related targets tasks and tests will be skipped. The
 same can be achieved by setting TOIL_DOCKER_REGISTRY to an empty string.
 
@@ -131,6 +136,11 @@
 	TOIL_SKIP_DOCKER=True \
 	    python -m pytest -vv --timeout=600 --strict-markers --log-level DEBUG --log-cli-level INFO $(cov) $(tests)
 
+# This target will run about 1 minute of tests, and stop at the first failure
+test_1min: check_venv check_build_reqs
+	TOIL_SKIP_DOCKER=True \
+	    python -m pytest -vv --timeout=10 --strict-markers --log-level DEBUG --log-cli-level INFO --maxfail=1 src/toil/test/batchSystems/batchSystemTest.py::SingleMachineBatchSystemTest::test_run_jobs src/toil/test/batchSystems/batchSystemTest.py::KubernetesBatchSystemBenchTest src/toil/test/server/serverTest.py::ToilWESServerBenchTest::test_get_service_info src/toil/test/cwl/cwlTest.py::CWLWorkflowTest::test_run_colon_output src/toil/test/jobStores/jobStoreTest.py::FileJobStoreTest::testUpdateBehavior
+
 ifdef TOIL_DOCKER_REGISTRY
 
 docker_image:=$(TOIL_DOCKER_REGISTRY)/$(TOIL_DOCKER_NAME)
@@ -149,7 +159,7 @@
 
 pre_pull_docker:
 	# Pre-pull everything
-	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull ubuntu:20.04 && break || sleep 60; done
+	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull ubuntu:22.04 && break || sleep 60; done
 	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull prom/prometheus:v2.24.1 && break || sleep 60; done
 	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull grafana/grafana && break || sleep 60; done
 	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull sscaling/mtail && break || sleep 60; done
@@ -191,9 +201,15 @@
 	cd dashboard/grafana ; for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker buildx build --platform $(arch) --push --tag=$(grafana_image):$(TOIL_DOCKER_TAG) -f Dockerfile . && break || sleep 60; done
 	cd dashboard/mtail ; for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker buildx build --platform $(arch) --push --tag=$(mtail_image):$(TOIL_DOCKER_TAG) -f Dockerfile . && break || sleep 60; done
 
+load_docker: docker
+	cd docker ; docker buildx build --platform $(arch) --load --tag=$(docker_image):$(TOIL_DOCKER_TAG) -f Dockerfile .
+	cd dashboard/prometheus ; docker buildx build --platform $(arch) --load --tag=$(prometheus_image):$(TOIL_DOCKER_TAG) -f Dockerfile . 
+	cd dashboard/grafana ; docker buildx build --platform $(arch) --load --tag=$(grafana_image):$(TOIL_DOCKER_TAG) -f Dockerfile .
+	cd dashboard/mtail ; docker buildx build --platform $(arch) --load --tag=$(mtail_image):$(TOIL_DOCKER_TAG) -f Dockerfile .
+
 else
 
-docker docker_push clean_docker:
+docker push_docker load_docker clean_docker:
 	@printf "$(cyan)Skipping '$@' target as TOIL_DOCKER_REGISTRY is empty or Docker is not installed.$(normal)\n"
 
 endif
@@ -240,7 +256,7 @@
 # Linting and code style related targets
 ## sorting imports using isort: https://github.com/timothycrosley/isort
 sort_imports: $(PYSOURCES)
-	isort -m VERTICAL $^
+	isort -m VERTICAL $^ contrib/mypy-stubs
 	make format
 
 remove_unused_imports: $(PYSOURCES)
@@ -251,38 +267,10 @@
 	$(CURDIR)/contrib/admin/remove_trailing_whitespace.py
 
 format: $(wildcard src/toil/cwl/*.py)
-	black $^
+	black $^ contrib/mypy-stubs
 
 mypy:
 	$(CURDIR)/contrib/admin/mypy-with-ignore.py
-
-pydocstyle_report.txt: src/toil
-	pydocstyle setup.py $^ > $@ 2>&1 || true
-
-diff_pydocstyle_report: pydocstyle_report.txt
-	diff-quality --compare-branch=master --violations=pycodestyle --fail-under=100 $^
-
-diff_mypy:
-	mypy --cobertura-xml-report . src/toil || true
-	diff-cover --fail-under=100 cobertura.xml
-
-pyupgrade: $(PYSOURCES)
-	pyupgrade --exit-zero-even-if-changed --py36-plus $^
-
-flake8: $(PYSOURCES)
-	flake8 --ignore=E501,W293,W291,E265,E302,E722,E126,E303,E261,E201,E202,W503,W504,W391,E128,E301,E127,E502,E129,E262,E111,E117,E306,E203,E231,E226,E741,E122,E251,E305,E701,E222,E225,E241,E305,E123,E121,E703,E704,E125,E402 $^
-
-.PHONY: help \
-		prepare \
-		check_cpickle \
-		develop clean_develop \
-		sdist clean_sdist \
-		test test_offline \
-		docs clean_docs \
-		clean \
-		format mypy sort_imports remove_unused_imports \
-		check_venv \
-		check_clean_working_copy \
-		check_build_reqs \
-		docker clean_docker push_docker \
-		pre_pull_docker toil_docker prometheus_docker grafana_docker mtail_docker
+	
+# This target will check any modified files for pylint errors.
+# We have a lot of pylint errors already, because pylint can't understand our

=== debian/changelog ===
toil (5.8.0-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * refresh patches; remove test_safe_paths & typing_fix, they were
    applied upstream.
  * new dependency: python3-pubsub
  * new patch to avoid unpackaged mypy_boto3_s3
  * Skip the aws/test_iam.py tests
  * python3-boto{,3} is now a hard requirement

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 12 Jan 2023 23:33:14 +0100

toil (5.7.1-2) unstable; urgency=medium

  * d/test/control: re-enable running on arm64

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 26 Dec 2022 16:06:23 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                python3-docker,
                python3-dill,
                python3-future,
-               cwltool (>= 3.1.20220628170238),
+               cwltool (>= 3.1.20221008225030),
                python3-distutils,
                python3-enlighten,
                python3-wdlparse,
@@ -23,8 +23,9 @@
                rsync <!nocheck>,
                python3-yaml <!nocheck>,
                python3-urllib3,
-               python3-sphinx
-Standards-Version: 4.6.1
+               python3-sphinx,
+               python3-pubsub <!nodoc>
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/toil
 Vcs-Git: https://salsa.debian.org/med-team/toil.git
 Homepage: https://github.com/BD2KGenomics/toil
@@ -35,11 +36,11 @@
 Depends: ${python3:Depends},
          ${misc:Depends},
          python3-distutils,
-         cwltool (>= 3.1.20211104071347)
-Recommends: python3-boto,
-            python3-boto3,
+         cwltool (>= 3.1.20221008225030),
+         python3-boto,
+         python3-boto3
 # for WDL support
-            python3-wdlparse,
+Recommends: python3-wdlparse,
 # for google cloud support
             python3-libcloud
 # for mesos support, but needs python3-mesos first

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	PYBUILD_SYSTEM=custom \
-		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -vv -W ignore --ignore src/toil/test/lib/aws/test_s3.py --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/toilwdlTest.py --ignore src/toil/test/cwl/cwlTest.py --ignore src/toil/test/src/promisedRequirementTest.py --ignore src/toil/test/lib/test_ec2.py --ignore src/toil/test/batchSystems/batchSystemTest.py -k "not (test_bioconda or test_run_conformance or testImportFtpFile or ToilWdlIntegrationTest or SortTest or testCwlexample or testVirtualEnv or ToilDocumentationTest or test_cwl_toil_kill or testImportReadFileCompatibility or CleanWorkDirTest or DeferredFunctionTest)" {dir}/src/toil/test' \
+		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -vv -W ignore --ignore src/toil/test/lib/aws/test_s3.py --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/toilwdlTest.py --ignore src/toil/test/cwl/cwlTest.py --ignore src/toil/test/src/promisedRequirementTest.py --ignore src/toil/test/lib/test_ec2.py --ignore src/toil/test/batchSystems/batchSystemTest.py --ignore src/toil/test/lib/aws/test_iam.py -k "not (test_bioconda or test_run_conformance or testImportFtpFile or ToilWdlIntegrationTest or SortTest or testCwlexample or testVirtualEnv or ToilDocumentationTest or test_cwl_toil_kill or testImportReadFileCompatibility or CleanWorkDirTest or DeferredFunctionTest)" {dir}/src/toil/test' \
 		dh_auto_test
 endif

=== debian/tests/control ===
--- 
+++ 
@@ -5,4 +5,3 @@
 Tests: run-unit-tests
 Depends: toil, python3, python3-wdlparse, python3-pytest, python3-mock, python3-boto3, rsync, python3-boto, python3-stubserver, python3-yaml, quilt
 Restrictions: allow-stderr, needs-internet
-Architecture: !arm64

## toil 5.9.0

=== debian/changelog ===
toil (5.9.0-1) unstable; urgency=medium

  * New upstream version
  * d/control: match build-deps to upstream
  * run tests in parallel

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 03 Feb 2023 19:05:54 +0100

toil (5.8.0-3) unstable; urgency=medium

  * d/patches/setting_version.patch: really keep the python minor
    version out

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 18 Jan 2023 15:24:50 +0100

toil (5.8.0-2) unstable; urgency=medium

  * set exactPython to "python3" to always use the system version
  * Recommend podman in addition to docker/singularity

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 15 Jan 2023 15:30:29 +0100

=== debian/control ===
--- 
+++ 
@@ -11,11 +11,13 @@
                python3-docker,
                python3-dill,
                python3-future,
-               cwltool (>= 3.1.20221008225030),
+               cwltool (>= 3.1.20221201130942),
+               python3-schema-salad (>= 8.4.20230128170514),
                python3-distutils,
                python3-enlighten,
                python3-wdlparse,
                python3-pytest <!nocheck>,
+               python3-xdist <!nocheck>,
                python3-mock <!nocheck>,
                python3-boto3 (>=1.17) <!nocheck>,
                python3-boto <!nocheck>,
@@ -36,7 +38,8 @@
 Depends: ${python3:Depends},
          ${misc:Depends},
          python3-distutils,
-         cwltool (>= 3.1.20221008225030),
+         cwltool (>= 3.1.20221201130942),
+         python3-schema-salad (>= 8.4.20230128170514),
          python3-boto,
          python3-boto3
 # for WDL support
@@ -45,7 +48,7 @@
             python3-libcloud
 # for mesos support, but needs python3-mesos first
 #         python3-protobuf,
-Suggests: docker.io | singularity-container | docker-ce,
+Suggests: podman | docker.io | singularity-container | docker-ce,
           python3-azure,
           python3-azure-storage,
           python3-idna,

## toil 5.9.2

=== Makefile ===
--- 
+++ 
@@ -41,7 +41,7 @@
 Targets are provided to run Toil's tests. Note that these targets do *not* automatically install
 Toil's dependencies; it is recommended to 'make develop' before running any of them.
 
-The 'test' target runs Toil's unit tests serially with pytest. It will run some docker tests and
+The 'test' target runs Toil's unit tests in parallel with pytest. It will run some docker tests and
 setup. Note: this target does not capture output from the terminal. For any of the test targets,
 set the 'tests' variable to run a particular test, e.g.
 
@@ -127,14 +127,15 @@
 # Setting SET_OWNER_TAG will tag cloud resources so that UCSC's cloud murder bot won't kill them.
 test: check_venv check_build_reqs
 	TOIL_OWNER_TAG="shared" \
-	    python -m pytest --durations=0 --strict-markers --log-level DEBUG --log-cli-level INFO -r s $(cov) $(tests)
+	    python -m pytest --durations=0 --strict-markers --log-level DEBUG --log-cli-level INFO -r s $(cov) -n auto --dist loadscope $(tests)
 
 
 # This target will skip building docker and all docker based tests
+# these are our travis tests; rename?
 test_offline: check_venv check_build_reqs
 	@printf "$(cyan)All docker related tests will be skipped.$(normal)\n"
 	TOIL_SKIP_DOCKER=True \
-	    python -m pytest -vv --timeout=600 --strict-markers --log-level DEBUG --log-cli-level INFO $(cov) $(tests)
+	    python -m pytest -vv --timeout=600 --strict-markers --log-level DEBUG --log-cli-level INFO $(cov) -n auto --dist loadscope $(tests)
 
 # This target will run about 1 minute of tests, and stop at the first failure
 test_1min: check_venv check_build_reqs
@@ -270,7 +271,5 @@
 	black $^ contrib/mypy-stubs
 
 mypy:
-	$(CURDIR)/contrib/admin/mypy-with-ignore.py
-	
-# This target will check any modified files for pylint errors.
-# We have a lot of pylint errors already, because pylint can't understand our
+	mypy --ignore-missing-imports --no-strict-optional \
+		--warn-redundant-casts --warn-unused-ignores \

=== requirements.txt ===
dill>=0.3.2, <0.4
requests>=2, <3
docker>=3.7.2, <6
python-dateutil
psutil >= 3.0.1, <6
py-tes>=0.4.2,<1
PyPubSub >=4.0.3, <5
addict>=2.2.1, <2.5
pytz>=2012
enlighten>=1.5.2, <2
typing-extensions

=== debian/changelog ===
toil (5.9.2-2+deb12u1) bookworm; urgency=medium

  * Team upload.
  * Apply patch by Michael R. Crusoe to request a single core
    in the tests. Closes: #1031192.

 -- Santiago Vila <sanvila@debian.org>  Tue, 21 Nov 2023 00:35:00 +0100

toil (5.9.2-2) unstable; urgency=medium

  * Add patch to handle errors when testing on ec2.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 06 Feb 2023 19:04:14 +0100

toil (5.9.2-1) unstable; urgency=medium

  * correct build-dep on pytest-xdist
  * d/test/control: depend on "@" instead of the unversioned "toil".
  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 04 Feb 2023 19:21:49 +0100

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
                python3-enlighten,
                python3-wdlparse,
                python3-pytest <!nocheck>,
-               python3-xdist <!nocheck>,
+               python3-pytest-xdist <!nocheck>,
                python3-mock <!nocheck>,
                python3-boto3 (>=1.17) <!nocheck>,
                python3-boto <!nocheck>,

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export PYBUILD_NAME=toil

export PYBUILD_DESTDIR_python3=debian/toil/

#export PYBUILD_DISABLE=test
export PYBUILD_DISABLE_python2=1
%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	PYTHONPATH=$(CURDIR)/src $(MAKE) -C docs man

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian -name cwltoil -delete
	# remove the below once mesos is packaged and tested
	find $(CURDIR)/debian -name _toil_mesos_executor -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	PYBUILD_SYSTEM=custom \
		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -n auto --dist loadscope -vv -W ignore --ignore src/toil/test/lib/aws/test_s3.py --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/toilwdlTest.py --ignore src/toil/test/cwl/cwlTest.py --ignore src/toil/test/src/promisedRequirementTest.py --ignore src/toil/test/lib/test_ec2.py --ignore src/toil/test/batchSystems/batchSystemTest.py --ignore src/toil/test/lib/aws/test_iam.py -k "not (test_bioconda or test_run_conformance or testImportFtpFile or ToilWdlIntegrationTest or SortTest or testCwlexample or testVirtualEnv or ToilDocumentationTest or test_cwl_toil_kill or testImportReadFileCompatibility or CleanWorkDirTest or DeferredFunctionTest)" {dir}/src/toil/test' \
		dh_auto_test
endif

# If you need to rebuild the Sphinx documentation
# Add spinxdoc to the dh --with line
#override_dh_auto_build:
#	dh_auto_build
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bhtml docs/ build/html # HTML generator
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bman  docs/ build/man  # Manpage generator

override_dh_auto_clean:
	rm -rf .pybuild
	rm -rf docs/_build
	find . -name "*.pyc" -delete

=== debian/tests/control ===
Tests: smoke-test
Depends: @, python3-wdlparse
Restrictions: allow-stderr, superficial

Tests: run-unit-tests
Depends: @, python3, python3-wdlparse, python3-pytest, python3-pytest-xdist, python3-mock, python3-boto3, rsync, python3-boto, python3-stubserver, python3-yaml, quilt
Restrictions: allow-stderr, needs-internet

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
https://github.com/BD2KGenomics/toil/tags .*/releases/@ANY_VERSION@.tar.gz

## toil 5.11.0

=== Makefile ===
--- 
+++ 
@@ -218,10 +218,10 @@
 
 docs: check_venv check_build_reqs
 	# Strange, but seemingly benign Sphinx warning floods stderr if not filtered:
-	cd docs && make html
+	cd docs && ${MAKE} html
 
 clean_docs: check_venv
-	- cd docs && make clean
+	- cd docs && ${MAKE} clean
 
 clean: clean_develop clean_sdist clean_docs
 
@@ -258,11 +258,11 @@
 ## sorting imports using isort: https://github.com/timothycrosley/isort
 sort_imports: $(PYSOURCES)
 	isort -m VERTICAL $^ contrib/mypy-stubs
-	make format
+	${MAKE} format
 
 remove_unused_imports: $(PYSOURCES)
 	autoflake --in-place --remove-all-unused-imports $^
-	make format
+	${MAKE} format
 
 remove_trailing_whitespace:
 	$(CURDIR)/contrib/admin/remove_trailing_whitespace.py

=== requirements.txt ===
--- 
+++ 
@@ -1,6 +1,8 @@
 dill>=0.3.2, <0.4
 requests>=2, <3
 docker>=3.7.2, <6
+# Work around https://github.com/docker/docker-py/issues/3113
+urllib3>=1.26.0, <2.0.0
 python-dateutil
 psutil >= 3.0.1, <6
 py-tes>=0.4.2,<1

=== debian/changelog ===
toil (5.11.0-2) unstable; urgency=medium

  * Exclude WDL from autopkgtests; as miniwdl isn't packaged yet for Debian

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 15 Jul 2023 09:43:56 +0200

toil (5.11.0-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version
  * Build-Depends: python3-sphinx-autoapi, python3-sphinx-autodoc-typehints,
                   python3-sphinxcontrib.autoprogram, docker.io

  [ Michael R. Crusoe ]
  * d/rules: skip the WDL tests (not packaged)
  * d/patches/setting_version.patch: update for Toil 5.11.0

 -- Andreas Tille <tille@debian.org>  Fri, 14 Jul 2023 22:43:13 +0200

=== debian/control ===
--- 
+++ 
@@ -24,8 +24,12 @@
                python3-stubserver <!nocheck>,
                rsync <!nocheck>,
                python3-yaml <!nocheck>,
+               docker.io <!nocheck>,
                python3-urllib3,
-               python3-sphinx,
+               python3-sphinx <!nodoc>,
+               python3-sphinx-autoapi <!nodoc>,
+               python3-sphinx-autodoc-typehints <!nodoc>,
+               python3-sphinxcontrib.autoprogram <!nodoc>,
                python3-pubsub <!nodoc>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/toil
@@ -42,12 +46,12 @@
          python3-schema-salad (>= 8.4.20230128170514),
          python3-boto,
          python3-boto3
+# for google cloud support
+Recommends: python3-libcloud
 # for WDL support
-Recommends: python3-wdlparse,
-# for google cloud support
-            python3-libcloud
+#           python3-wdlparse,
 # for mesos support, but needs python3-mesos first
-#         python3-protobuf,
+#           python3-protobuf,
 Suggests: podman | docker.io | singularity-container | docker-ce,
           python3-azure,
           python3-azure-storage,

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export PYBUILD_NAME=toil

export PYBUILD_DESTDIR_python3=debian/toil/

#export PYBUILD_DISABLE=test
export PYBUILD_DISABLE_python2=1
%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	PYTHONPATH=$(CURDIR)/src $(MAKE) -C docs man

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian -name cwltoil -delete
	# remove the below once mesos is packaged and tested
	find $(CURDIR)/debian -name _toil_mesos_executor -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	PYBUILD_SYSTEM=custom \
		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -n auto --dist loadscope -vv -W ignore --ignore src/toil/test/lib/aws/test_s3.py --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/toilwdlTest.py --ignore src/toil/test/cwl/cwlTest.py --ignore src/toil/test/src/promisedRequirementTest.py --ignore src/toil/test/lib/test_ec2.py --ignore src/toil/test/batchSystems/batchSystemTest.py --ignore src/toil/test/lib/aws/test_iam.py -k "not (test_bioconda or test_run_conformance or testImportFtpFile or ToilWdlIntegrationTest or SortTest or testCwlexample or testVirtualEnv or ToilDocumentationTest or test_cwl_toil_kill or testImportReadFileCompatibility or CleanWorkDirTest or DeferredFunctionTest or WdlToilTest)" {dir}/src/toil/test' \
		dh_auto_test
endif

# If you need to rebuild the Sphinx documentation
# Add spinxdoc to the dh --with line
#override_dh_auto_build:
#	dh_auto_build
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bhtml docs/ build/html # HTML generator
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bman  docs/ build/man  # Manpage generator

override_dh_auto_clean:
	rm -rf .pybuild
	rm -rf docs/_build
	find . -name "*.pyc" -delete
